#ifndef OBJ_H
#define OBJ_H
#include "config.h"
#include "param.h"
#include "bin_deg.h"

typedef enum {
    oc_edible,
    oc_enemy,
} obj_class_t;
    
typedef enum {
              ot_egg=0, ot_begin=0,
              ot_rat,
              ot_chickpea,

              ot_frog,
              ot_end
} obj_type_t;

typedef struct {
    int valid;
    double x, y;
    obj_type_t type;
    double dest_x, dest_y;
    bin_deg_t deg;
    int ctr1, ctr2;
} obj_t;

typedef void (*obj_callback_t)(obj_t*);

typedef struct {
    obj_callback_t setup;
    obj_callback_t act;
    obj_callback_t draw;
} obj_funcs_t;    

typedef struct {
    char *name;
    int xsize;
    int ysize;
} obj_stats_t;

typedef struct {
    obj_class_t class;
    obj_type_t type;
    obj_stats_t stats;
    obj_funcs_t funcs;
} obj_info_t;


void obj_init(void);
void setup_obj_classic(void);
void setup_obj_uroboros(void);
void obj_iterator(obj_callback_t callback);
void obj_iterator_draw(void);
void obj_iterator_act(void);
int is_obj_overlapped(obj_t *obj1, obj_t *obj2, int dist2);
int is_overlapped(double x1, double y1, double x2, double y2, int dist2);

    
#endif
